diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.33/src/wifi/model/wifi-phy.h ns-3.34/src/wifi/model/wifi-phy.h
--- ns-3.33/src/wifi/model/wifi-phy.h	2021-01-09 10:19:23.000000000 -0800
+++ ns-3.34/src/wifi/model/wifi-phy.h	2021-07-14 10:31:07.000000000 -0700
@@ -1441,21 +688,6 @@
   typedef void (* PsduTxBeginCallback)(WifiConstPsduMap psduMap, WifiTxVector txVector, double txPowerW);
 
   /**
-   * Public method used to fire a EndOfHePreamble trace once both HE SIG fields have been received, as well as training fields.
-   *
-   * \param params the HE preamble parameters
-   */
-  void NotifyEndOfHePreamble (HePreambleParameters params);
-
-  /**
-   * TracedCallback signature for end of HE-SIG-A events.
-   *
-   *
-   * \param params the HE preamble parameters
-   */
-  typedef void (* EndOfHePreambleCallback)(HePreambleParameters params);
-
-  /**
    * TracedCallback signature for start of PSDU reception events.
    *
    * \param txVector the TXVECTOR decoded from the PHY header
@@ -1605,6 +837,29 @@
   Ptr<MobilityModel> GetMobility (void) const;
 
   /**
+   * Set the operating channel according to the specified parameters. If this object
+   * has been already initialized, setting the operating channel involves a channel
+   * switch, which might be suppressed (e.g., if this object is in sleep mode) or
+   * delayed (e.g., if this object is transmitting a frame).
+   *
+   * \param number the channel number (use 0 to leave it unspecified)
+   * \param frequency the channel center frequency in MHz (use 0 to leave it unspecified)
+   * \param width the channel width in MHz (use 0 to leave it unspecified)
+   */
+  void SetOperatingChannel (uint8_t number, uint16_t frequency, uint16_t width);
+  /**
+   * If the operating channel for this object has not been set yet, the given
+   * center frequency is saved and will be used, along with the channel number and
+   * width that have been saved similarly, to set the operating channel when the
+   * standard and band are configured. Note that if center frequency and
+   * channel number are both 0 when the standard and band are configured, a default
+   * channel (of the configured width, if any, or the default width for the current
+   * standard and band, otherwise) is set.
+   * If the operating channel for this object has been already set, the specified
+   * center frequency must uniquely identify a channel in the band being used. If so,
+   * this method may still fail to take action if the PHY model determines that
+   * the operating channel cannot be switched for some reason (e.g. sleep state)
+   *
    * \param freq the operating center frequency (MHz) on this node.
    */
   virtual void SetFrequency (uint16_t freq);
@@ -1613,6 +868,13 @@
    */
   uint16_t GetFrequency (void) const;
   /**
+   * Set the index of the primary 20 MHz channel (0 indicates the 20 MHz subchannel
+   * with the lowest center frequency).
+   *
+   * \param index the index of the primary 20 MHz channel
+   */
+  void SetPrimary20Index (uint8_t index);
+  /**
    * \param antennas the number of antennas on this node.
    */
   void SetNumberOfAntennas (uint8_t antennas);
@@ -1691,6 +953,17 @@
    */
   uint16_t GetChannelWidth (void) const;
   /**
+   * If the operating channel for this object has not been set yet, the given
+   * channel width is saved and will be used, along with the center frequency and
+   * channel number that have been saved similarly, to set the operating channel
+   * when the standard and band are configured. Note that if center frequency and
+   * channel number are both 0 when the standard and band are configured, a default
+   * channel (of the configured width, if any, or the default width for the current
+   * standard and band, otherwise) is set.
+   * Do not call this method when the standard and band of this object have been
+   * already configured, because it cannot uniquely identify a channel in the band
+   * being used.
+   *
    * \param channelWidth the channel width (in MHz)
    */
   virtual void SetChannelWidth (uint16_t channelWidth);
@@ -1722,12 +995,14 @@
    */
   void ResetCca (bool powerRestricted, double txPowerMaxSiso = 0, double txPowerMaxMimo = 0);
   /**
-   * Compute the transmit power (in dBm) for the next transmission.
+   * Compute the transmit power for the next transmission.
+   * The returned power will satisfy the power density constraints
+   * after addition of antenna gain.
    *
-   * \param txVector the TXVECTOR
+   * \param ppdu the PPDU to transmit
    * \return the transmit power in dBm for the next transmission
    */
-  double GetTxPowerForTransmission (WifiTxVector txVector) const;
+  double GetTxPowerForTransmission (Ptr<const WifiPpdu> ppdu) const;
   /**
    * Notify the PHY that an access to the channel was requested.
    * This is typically called by the channel access manager to
@@ -1738,47 +1013,116 @@
   void NotifyChannelAccessRequested (void);
 
 
+  /**
+   * \param bandWidth the width (MHz) of the band used for the OFDMA transmission. Must be
+   *                  a multiple of 20 MHz
+   * \param guardBandwidth width of the guard band (MHz)
+   * \param range the subcarrier range of the HE RU
+   * \param bandIndex the index (starting at 0) of the band within the operating channel
+   * \return the converted subcarriers
+   *
+   * This is a helper function to convert HE RU subcarriers, which are relative to the center frequency subcarrier, to the indexes used by the Spectrum model.
+   */
+  virtual WifiSpectrumBand ConvertHeRuSubcarriers (uint16_t bandWidth, uint16_t guardBandwidth,
+                                                   HeRu::SubcarrierRange range, uint8_t bandIndex = 0) const;
+
+  /**
+   * Add the PHY entity to the map of __implemented__ PHY entities for the
+   * given modulation class.
+   * Through this method, child classes can add their own PHY entities in
+   * a static manner.
+   *
+   * \param modulation the modulation class
+   * \param phyEntity the PHY entity
+   */
+  static void AddStaticPhyEntity (WifiModulationClass modulation, Ptr<PhyEntity> phyEntity);
+
+  /**
+   * Get the __implemented__ PHY entity corresponding to the modulation class.
+   * This is used to compute the different amendment-specific parameters within
+   * calling static methods.
+   *
+   * \param modulation the modulation class
+   * \return the pointer to the static implemented PHY entity
+   */
+  static const Ptr<const PhyEntity> GetStaticPhyEntity (WifiModulationClass modulation);
+
+  /**
+   * Get the supported PHY entity corresponding to the modulation class, for
+   * the WifiPhy instance.
+   *
+   * \param modulation the modulation class
+   * \return the pointer to the supported PHY entity
+   */
+  Ptr<PhyEntity> GetPhyEntity (WifiModulationClass modulation) const;
+
+  /**
+   * \return the UID of the previously received PPDU (reset to UINT64_MAX upon transmission)
+   */
+  uint64_t GetPreviouslyRxPpduUid (void) const;
+
+  /**
+   * \param currentChannelWidth channel width of the current transmission (MHz)
+   * \return the width of the guard band (MHz)
+   *
+   * Note: in order to properly model out of band transmissions for OFDM, the guard
+   * band has been configured so as to expand the modeled spectrum up to the
+   * outermost referenced point in "Transmit spectrum mask" sections' PSDs of
+   * each PHY specification of 802.11-2016 standard. It thus ultimately corresponds
+   * to the current channel bandwidth (which can be different from devices max
+   * channel width).
+   *
+   * This method is only relevant for SpectrumWifiPhy.
+   */
+  virtual uint16_t GetGuardBandwidth (uint16_t currentChannelWidth) const = 0;
+  /**
+   * \return a tuple containing the minimum rejection (in dBr) for the inner band,
+   *                            the minimum rejection (in dBr) for the outer band, and
+   *                            the maximum rejection (in dBr) for the outer band
+   *                            for the transmit spectrum mask.
+   *
+   * This method is only relevant for SpectrumWifiPhy.
+   */
+  virtual std::tuple<double, double, double> GetTxMaskRejectionParams (void) const = 0;
+
 protected:
-  // Inherited
-  virtual void DoInitialize (void);
   virtual void DoDispose (void);
 
   /**
-   * The default implementation does nothing and returns true.  This method
-   * is typically called internally by SetChannelNumber ().
-   *
-   * \brief Perform any actions necessary when user changes channel number
-   * \param id channel number to try to switch to
-   * \return true if WifiPhy can actually change the number; false if not
-   * \see SetChannelNumber
+   * Reset data upon end of TX or RX
    */
-  bool DoChannelSwitch (uint8_t id);
+  void Reset (void);
+
   /**
-   * The default implementation does nothing and returns true.  This method
-   * is typically called internally by SetFrequency ().
+   * Perform any actions necessary when user changes operating channel after
+   * initialization.
    *
-   * \brief Perform any actions necessary when user changes frequency
-   * \param frequency frequency to try to switch to in MHz
-   * \return true if WifiPhy can actually change the frequency; false if not
-   * \see SetFrequency
+   * \return zero if the PHY can immediately switch channel, a positive value
+   *         indicating the amount of time to wait until the channel switch can
+   *         be performed or a negative value indicating that channel switch is
+   *         currently not possible (i.e., the radio is in sleep mode)
    */
-  bool DoFrequencySwitch (uint16_t frequency);
+  Time DoChannelSwitch (void);
 
   /**
    * Check if PHY state should move to CCA busy state based on current
    * state of interference tracker.  In this model, CCA becomes busy when
    * the aggregation of all signals as tracked by the InterferenceHelper
    * class is higher than the CcaEdThreshold
+   *
+   * \param channelWidth the channel width in MHz used for RSSI measurement
    */
-  void SwitchMaybeToCcaBusy (void);
+  void SwitchMaybeToCcaBusy (uint16_t channelWidth);
 
   /**
-   * Return the STA ID that has been assigned to the station this PHY belongs to.
-   * This is typically called for MU PPDUs, in order to pick the correct PSDU.
+   * Return the channel width used to measure the RSSI.
+   * This corresponds to the primary channel unless it corresponds to the
+   * HE TB PPDU solicited by the AP.
    *
-   * \return the STA ID
+   * \param ppdu the PPDU that is being received
+   * \return the channel width (in MHz) used for RSSI measurement
    */
-  virtual uint16_t GetStaId (void) const;
+  uint16_t GetMeasurementChannelWidth (const Ptr<const WifiPpdu> ppdu) const;
 
   /**
    * Get the start band index and the stop band index for a given band
@@ -1791,39 +1135,66 @@
   virtual WifiSpectrumBand GetBand (uint16_t bandWidth, uint8_t bandIndex = 0);
 
   /**
-   * \param channelWidth the total channel width (MHz) used for the OFDMA transmission
-   * \param range the subcarrier range of the HE RU
-   * \return the converted subcarriers
+   * If the operating channel width is a multiple of 20 MHz, return the start
+   * band index and the stop band index for the primary channel of the given
+   * bandwidth (which must be a multiple of 20 MHz and not exceed the operating
+   * channel width). Otherwise, this call is equivalent to GetBand with
+   * <i>bandIndex</i> equal to zero.
    *
-   * This is a helper function to convert HE RU subcarriers, which are relative to the center frequency subcarrier, to the indexes used by the Spectrum model.
+   * \param bandWidth the width of the band to be returned (MHz)
+   *
+   * \return a pair of start and stop indexes that defines the band
+   */
+  WifiSpectrumBand GetPrimaryBand (uint16_t bandWidth);
+
+  /**
+   * Add the PHY entity to the map of supported PHY entities for the
+   * given modulation class for the WifiPhy instance.
+   * This is a wrapper method used to check that the PHY entity is
+   * in the static map of implemented PHY entities (\see m_staticPhyEntities).
+   * In addition, child classes can add their own PHY entities.
+   *
+   * \param modulation the modulation class
+   * \param phyEntity the PHY entity
    */
-  virtual WifiSpectrumBand ConvertHeRuSubcarriers (uint16_t channelWidth, HeRu::SubcarrierRange range) const;
+  void AddPhyEntity (WifiModulationClass modulation, Ptr<PhyEntity> phyEntity);
 
-  InterferenceHelper m_interference;   //!< Pointer to InterferenceHelper
+  InterferenceHelper m_interference;   //!< the class handling interference computations
   Ptr<UniformRandomVariable> m_random; //!< Provides uniform random variables.
   Ptr<WifiPhyStateHelper> m_state;     //!< Pointer to WifiPhyStateHelper
 
   uint32_t m_txMpduReferenceNumber;    //!< A-MPDU reference number to identify all transmitted subframes belonging to the same received A-MPDU
   uint32_t m_rxMpduReferenceNumber;    //!< A-MPDU reference number to identify all received subframes belonging to the same received A-MPDU
 
-  EventId m_endRxEvent;                //!< the end of receive event
   EventId m_endPhyRxEvent;             //!< the end of PHY receive event
-  EventId m_endPreambleDetectionEvent; //!< the end of preamble detection event
-
   EventId m_endTxEvent;                //!< the end of transmit event
 
-private:
+  Ptr<Event> m_currentEvent; //!< Hold the current event
+  std::map <std::pair<uint64_t /* UID*/, WifiPreamble>, Ptr<Event> > m_currentPreambleEvents; //!< store event associated to a PPDU (that has a unique ID and preamble combination) whose preamble is being received
+
+  uint64_t m_previouslyRxPpduUid;  //!< UID of the previously received PPDU, reset to UINT64_MAX upon transmission
+
   /**
-   * \brief post-construction setting of frequency and/or channel number
+   * This map holds the supported PHY entities.
+   *
+   * The set of parameters (e.g. mode) that this WifiPhy(-derived class) can
+   * support can be obtained through it.
+   *
+   * When it comes to modes, in conversation we call this set
+   * the DeviceRateSet (not a term you'll find in the standard), and
+   * it is a superset of standard-defined parameters such as the
+   * OperationalRateSet, and the BSSBasicRateSet (which, themselves,
+   * have a superset/subset relationship).
    *
-   * This method exists to handle the fact that two attribute values,
-   * Frequency and ChannelNumber, are coupled.  The initialization of
-   * these values needs to be deferred until after attribute construction
-   * time, to avoid static initialization order issues.  This method is
-   * typically called either when ConfigureStandard () is called or when
-   * DoInitialize () is called.
+   * Mandatory rates relevant to this WifiPhy can be found by
+   * iterating over the elements of this map, for each modulation class,
+   * looking for WifiMode objects for which
+   * WifiMode::IsMandatory() is true.
    */
-  void InitializeFrequencyChannelNumber (void);
+  std::map<WifiModulationClass, Ptr<PhyEntity> > m_phyEntities;
+
+
+private:
   /**
    * Configure WifiPhy with appropriate channel frequency and
    * supported rates for 802.11a standard.
@@ -1846,11 +1217,6 @@
   void Configure80211p (void);
   /**
    * Configure WifiPhy with appropriate channel frequency and
-   * supported rates for Holland.
-   */
-  void ConfigureHolland (void);
-  /**
-   * Configure WifiPhy with appropriate channel frequency and
    * supported rates for 802.11n standard.
    */
   void Configure80211n (void);
@@ -1879,35 +1245,6 @@
    * Rebuild the mapping of MCS values to indices in the device MCS set.
    */
   void RebuildMcsMap (void);
-  /**
-   * Configure the PHY-level parameters for different Wi-Fi standard.
-   * This method is called when defaults for each standard must be
-   * selected.
-   */
-  void ConfigureDefaultsForStandard (void);
-  /**
-   * Configure the PHY-level parameters for different Wi-Fi standard.
-   * This method is called when the Frequency or ChannelNumber attributes
-   * are set by the user.  If the Frequency or ChannelNumber are valid for
-   * the standard, they are used instead.
-   */
-  void ConfigureChannelForStandard (void);
-
-  /**
-   * Look for channel number matching the frequency and width
-   * \param frequency The center frequency to use in MHz
-   * \param width The channel width to use in MHz
-   * \return the channel number if found, zero if not
-   */
-  uint8_t FindChannelNumberForFrequencyWidth (uint16_t frequency, uint16_t width) const;
-  /**
-   * Lookup frequency/width pair for channelNumber/standard pair
-   * \param channelNumber The channel number to check
-   * \param band the PHY band to check
-   * \param standard The WifiPhyStandard to check
-   * \return the FrequencyWidthPair found
-   */
-  FrequencyWidthPair GetFrequencyWidthForChannelNumberStandard (uint8_t channelNumber, WifiPhyBand band, WifiPhyStandard standard) const;
 
   /**
    * Due to newly arrived signal, the current reception cannot be continued and has to be aborted
@@ -1918,47 +1255,9 @@
 
   /**
    * Eventually switch to CCA busy
+   * \param channelWidth the channel width in MHz used for RSSI measurement
    */
-  void MaybeCcaBusyDuration (void);
-
-  /**
-   * Starting receiving the PPDU after having detected the medium is idle or after a reception switch.
-   *
-   * \param event the event holding incoming PPDU's information
-   */
-  void StartRx (Ptr<Event> event);
-  /**
-   * Get the reception status for the provided MPDU and notify.
-   *
-   * \param psdu the arriving MPDU formatted as a PSDU
-   * \param event the event holding incoming PPDU's information
-   * \param staId the station ID of the PSDU (only used for MU)
-   * \param relativeMpduStart the relative start time of the MPDU within the A-MPDU. 0 for normal MPDUs
-   * \param mpduDuration the duration of the MPDU
-   *
-   * \return information on MPDU reception: status, signal power (dBm), and noise power (in dBm)
-   */
-  std::pair<bool, SignalNoiseDbm> GetReceptionStatus (Ptr<const WifiPsdu> psdu,
-                                                      Ptr<Event> event, uint16_t staId,
-                                                      Time relativeMpduStart,
-                                                      Time mpduDuration);
-  /**
-   * The last symbol of an MPDU in an A-MPDU has arrived.
-   *
-   * \param event the event holding incoming PPDU's information
-   * \param psdu the arriving MPDU formatted as a PSDU containing a normal MPDU
-   * \param mpduIndex the index of the MPDU within the A-MPDU
-   * \param relativeMpduStart the relative start time of the MPDU within the A-MPDU.
-   * \param mpduDuration the duration of the MPDU
-   */  
-  void EndOfMpdu (Ptr<Event> event, Ptr<const WifiPsdu> psdu, size_t mpduIndex, Time relativeStart, Time mpduDuration);
-
-  /**
-   * Schedule end of MPDUs events.
-   *
-   * \param event the event holding incoming PPDU's information
-   */
-  void ScheduleEndOfMpdus (Ptr<Event> event);
+  void MaybeCcaBusyDuration (uint16_t channelWidth);
 
   /**
    * Get the PSDU addressed to that PHY in a PPDU (useful for MU PPDU).
@@ -1969,16 +1268,6 @@
   Ptr<const WifiPsdu> GetAddressedPsduInPpdu (Ptr<const WifiPpdu> ppdu) const;
 
   /**
-   * Get the RU band used to transmit a PSDU to a given STA in a HE MU PPDU
-   *
-   * \param txVector the TXVECTOR used for the transmission
-   * \param staId the STA-ID of the recipient
-   *
-   * \return the RU band used to transmit a PSDU to a given STA in a HE MU PPDU
-   */
-  WifiSpectrumBand GetRuBand (WifiTxVector txVector, uint16_t staId);
-
-  /**
    * The trace source fired when a packet begins the transmission process on
    * the medium.
    *
@@ -2077,62 +1366,22 @@
   TracedCallback<Ptr<const Packet>, uint16_t /* frequency (MHz) */, WifiTxVector, MpduInfo, uint16_t /* STA-ID*/> m_phyMonitorSniffTxTrace;
 
   /**
-   * A trace source that indicates the end of both HE SIG fields as well as training fields for received 802.11ax packets
-   *
-   * \see class CallBackTraceSource
+   * Map of __implemented__ PHY entities. This is used to compute the different
+   * amendment-specific parameters in a static manner.
+   * For PHY entities supported by a given WifiPhy instance,
+   * \see m_phyEntities.
    */
-  TracedCallback<HePreambleParameters> m_phyEndOfHePreambleTrace;
-
-  /**
-   * This vector holds the set of transmission modes that this
-   * WifiPhy(-derived class) can support. In conversation we call this
-   * the DeviceRateSet (not a term you'll find in the standard), and
-   * it is a superset of standard-defined parameters such as the
-   * OperationalRateSet, and the BSSBasicRateSet (which, themselves,
-   * have a superset/subset relationship).
-   *
-   * Mandatory rates relevant to this WifiPhy can be found by
-   * iterating over this vector looking for WifiMode objects for which
-   * WifiMode::IsMandatory() is true.
-   *
-   * A quick note is appropriate here (well, here is as good a place
-   * as any I can find)...
-   *
-   * In the standard there is no text that explicitly precludes
-   * production of a device that does not support some rates that are
-   * mandatory (according to the standard) for PHYs that the device
-   * happens to fully or partially support.
-   *
-   * This approach is taken by some devices which choose to only support,
-   * for example, 6 and 9 Mbps ERP-OFDM rates for cost and power
-   * consumption reasons (i.e., these devices don't need to be designed
-   * for and waste current on the increased linearity requirement of
-   * higher-order constellations when 6 and 9 Mbps more than meet their
-   * data requirements). The wording of the standard allows such devices
-   * to have an OperationalRateSet which includes 6 and 9 Mbps ERP-OFDM
-   * rates, despite 12 and 24 Mbps being "mandatory" rates for the
-   * ERP-OFDM PHY.
-   *
-   * Now this doesn't actually have any impact on code, yet. It is,
-   * however, something that we need to keep in mind for the
-   * future. Basically, the key point is that we can't be making
-   * assumptions like "the Operational Rate Set will contain all the
-   * mandatory rates".
-   */
-  WifiModeList m_deviceRateSet;
-  WifiModeList m_deviceMcsSet; //!< the device MCS set
-  /// Maps MCS values to indices in m_deviceMcsSet, for HT, VHT and HE modulation classes
-  std::map<WifiModulationClass, std::map<uint8_t /* MCS value */, uint8_t /* index */>> m_mcsIndexMap;
-
-  std::vector<uint8_t> m_bssMembershipSelectorSet; //!< the BSS membership selector set
+  static std::map<WifiModulationClass, Ptr<PhyEntity> > m_staticPhyEntities;
 
   WifiPhyStandard m_standard;               //!< WifiPhyStandard
   WifiPhyBand m_band;                       //!< WifiPhyBand
-  bool m_isConstructed;                     //!< true when ready to set frequency
-  uint16_t m_channelCenterFrequency;        //!< Center frequency in MHz
   uint16_t m_initialFrequency;              //!< Store frequency until initialization (MHz)
-  bool m_frequencyChannelNumberInitialized; //!< Store initialization state
-  uint16_t m_channelWidth;                  //!< Channel width (MHz)
+  uint8_t m_initialChannelNumber;           //!< Store channel number until initialization
+  uint16_t m_initialChannelWidth;           //!< Store channel width (MHz) until initialization
+  uint8_t m_initialPrimary20Index;          //!< Store the index of primary20 until initialization
+
+  WifiPhyOperatingChannel m_operatingChannel;       //!< Operating channel
+  std::vector<uint16_t> m_supportedChannelWidthSet; //!< Supported channel width set (MHz)
 
   Time m_sifs;                              //!< Short Interframe Space (SIFS) duration
   Time m_slot;                              //!< Slot duration
@@ -2147,6 +1396,7 @@
   double   m_txPowerBaseDbm;      //!< Minimum transmission power (dBm)
   double   m_txPowerEndDbm;       //!< Maximum transmission power (dBm)
   uint8_t  m_nTxPower;            //!< Number of available transmission power levels
+  double m_powerDensityLimit;     //!< the power density limit (dBm/MHz)
 
   bool m_powerRestricted;        //!< Flag whether transmit power is restricted by OBSS PD SR
   double m_txPowerMaxSiso;       //!< SISO maximum transmit power due to OBSS PD SR power restriction (dBm)
@@ -2158,31 +1408,27 @@
   uint8_t m_txSpatialStreams;  //!< Number of supported TX spatial streams
   uint8_t m_rxSpatialStreams;  //!< Number of supported RX spatial streams
 
-  typedef std::map<ChannelNumberStandardPair, FrequencyWidthPair> ChannelToFrequencyWidthMap; //!< channel to frequency width map typedef
-  static ChannelToFrequencyWidthMap m_channelToFrequencyWidth;                               //!< the channel to frequency width map
-
-  std::vector<uint16_t> m_supportedChannelWidthSet; //!< Supported channel width set (MHz)
-  uint8_t               m_channelNumber;            //!< Operating channel number
-  uint8_t               m_initialChannelNumber;     //!< Initial channel number
-
   Time m_channelSwitchDelay;     //!< Time required to switch between channel
 
   Ptr<NetDevice>     m_device;   //!< Pointer to the device
   Ptr<MobilityModel> m_mobility; //!< Pointer to the mobility model
 
-  Ptr<Event> m_currentEvent;                            //!< Hold the current event
   Ptr<FrameCaptureModel> m_frameCaptureModel;           //!< Frame capture model
   Ptr<PreambleDetectionModel> m_preambleDetectionModel; //!< Preamble detection model
   Ptr<WifiRadioEnergyModel> m_wifiRadioEnergyModel;     //!< Wifi radio energy model
   Ptr<ErrorModel> m_postReceptionErrorModel;            //!< Error model for receive packet events
   Time m_timeLastPreambleDetected;                      //!< Record the time the last preamble was detected
 
-  std::vector<bool> m_statusPerMpdu; //!<  current reception status per MPDU that is filled in as long as MPDUs are being processed by the PHY in case of an A-MPDU
-  SignalNoiseDbm m_signalNoise;      //!< latest signal power and noise power in dBm (noise power includes the noise figure)
-
-  Callback<void> m_capabilitiesChangedCallback;         //!< Callback when PHY capabilities changed
+  Callback<void> m_capabilitiesChangedCallback; //!< Callback when PHY capabilities changed
 };
 
+/**
+ * \param os           output stream
+ * \param rxSignalInfo received signal info to stringify
+ * \return output stream
+ */
+std::ostream& operator<< (std::ostream& os, RxSignalInfo rxSignalInfo);
+
 } //namespace ns3
 
 #endif /* WIFI_PHY_H */
